## apksigcopier 1.0.1

=== Makefile ===
SHELL   := /bin/bash
PYTHON  ?= python3

export PYTHONWARNINGS := default

.PHONY: all install test test-cli lint lint-extra clean cleanup

all: apksigcopier.1

install:
	$(PYTHON) -mpip install -e .

test: test-cli lint lint-extra

test-cli:
	# TODO
	apksigcopier --version
	$(PYTHON) -m doctest apksigcopier

lint:
	flake8 apksigcopier.py
	pylint apksigcopier.py

lint-extra:
	mypy apksigcopier.py

clean: cleanup
	rm -fr apksigcopier.egg-info/

cleanup:
	find -name '*~' -delete -print
	rm -fr __pycache__/ .mypy_cache/
	rm -fr build/ dist/
	rm -fr .coverage htmlcov/
	rm -fr apksigcopier.1

%.1: %.1.md
	pandoc -s -t man -o $@ $<

.PHONY: _package _publish

_package:
	$(PYTHON) setup.py sdist bdist_wheel
	twine check dist/*

_publish: cleanup _package
	read -r -p "Are you sure? "; \
	[[ "$$REPLY" == [Yy]* ]] && twine upload dist/*

=== debian/changelog ===
apksigcopier (1.0.1-1) unstable; urgency=medium

  * New upstream version 1.0.1
  * debian/control: update description

 -- Felix C. Stegerman <flx@obfusk.net>  Thu, 08 Jul 2021 10:05:18 +0200

apksigcopier (1.0.0-2) unstable; urgency=medium

  * Add debian/watch file and upstream signing key.

 -- Felix C. Stegerman <flx@obfusk.net>  Wed, 30 Jun 2021 16:21:07 +0200

apksigcopier (1.0.0-1) unstable; urgency=medium

  * New upstream version 1.0.0
    - add compare command
  * debian/control: Suggests: apksigner
  * debian/rules: override dh_auto_test to run make test

 -- Felix C. Stegerman <flx@obfusk.net>  Fri, 18 Jun 2021 19:04:51 +0200

apksigcopier (0.5.0-1) unstable; urgency=medium

  * Initial release. Closes: #986179

 -- Felix C. Stegerman <flx@obfusk.net>  Thu, 15 Apr 2021 18:21:58 +0200

=== debian/control ===
Source: apksigcopier
Section: misc
Priority: optional
Maintainer: Felix C. Stegerman <flx@obfusk.net>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3-all,
               python3-click,
               python3-setuptools,
               flake8,
               pylint,
               mypy,
               pandoc,
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/obfusk/apksigcopier.git
Vcs-Browser: https://salsa.debian.org/obfusk/apksigcopier
Homepage: https://github.com/obfusk/apksigcopier
Rules-Requires-Root: no

Package: apksigcopier
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Suggests: apksigner
Description: copy/extract/patch android apk signatures & compare apks
 apksigcopier is a tool for copying android APK signatures from a signed APK to
 an unsigned one (in order to verify reproducible builds).  It can also be used
 to compare two APKs with different signatures.  Its command-line tool offers
 four operations:
 .
  * copy signatures directly from a signed to an unsigned APK
  * extract signatures from a signed APK to a directory
  * patch previously extracted signatures onto an unsigned APK
  * compare two APKs with different signatures (requires apksigner)

=== debian/rules ===
#!/usr/bin/make -f
execute_after_dh_auto_build:
	$(MAKE) apksigcopier.1
execute_after_dh_auto_clean:
	$(MAKE) clean
override_dh_auto_test:
	PATH=$$PWD:$$PATH $(MAKE) test
%:
	dh $@ --with python3 --buildsystem=pybuild

=== debian/tests/control ===
Tests: smoke
Depends: apksigcopier
Restrictions: allow-stderr, superficial

Tests: compare
Depends: apksigcopier, apksigner, wget
Restrictions: allow-stderr, needs-internet, skippable

## apksigcopier 1.1.0

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 export PYTHONWARNINGS := default
 
-.PHONY: all install test test-cli lint lint-extra clean cleanup
+.PHONY: all install test test-cli test-apks lint lint-extra clean cleanup
 
 all: apksigcopier.1
 
@@ -15,14 +15,19 @@
 test-cli:
 	# TODO
 	apksigcopier --version
-	$(PYTHON) -m doctest apksigcopier
+	$(PYTHON) -m doctest apksigcopier/__init__.py
+
+test-apks:
+	cd test/apks && diff -Naur ../test-compare.out <( ../test-compare.sh \
+	  | sed -r 's!/tmp/[^/]*/!/tmp/.../!' \
+	  | sed -r 's!Expected: <[0-9a-f]+>, actual: <[0-9a-f]+>!Expected: <...>, actual: <...>!' )
 
 lint:
-	flake8 apksigcopier.py
-	pylint apksigcopier.py
+	flake8 apksigcopier/__init__.py
+	pylint apksigcopier/__init__.py
 
 lint-extra:
-	mypy apksigcopier.py
+	mypy apksigcopier/__init__.py
 
 clean: cleanup
 	rm -fr apksigcopier.egg-info/

=== debian/changelog ===
apksigcopier (1.1.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- FC Stegerman <flx@obfusk.net>  Sat, 05 Nov 2022 18:37:27 +0100

apksigcopier (1.1.0-1) unstable; urgency=medium

  * New upstream version 1.1.0.
  * d/rules:
    - don't run linters. Closes: #1022411
    - use ./bin in PATH now that apksigcopier is a package.
  * d/control:
    - drop no longer needed Build-Depends: for linters.
    - bump Standards-Version to 4.6.1 (no changes required).
  * d/copyright: cleanup (minor).

 -- FC Stegerman <flx@obfusk.net>  Wed, 02 Nov 2022 00:29:15 +0100

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,6 @@
 execute_after_dh_auto_clean:
 	$(MAKE) clean
 override_dh_auto_test:
-	PATH=$$PWD:$$PATH $(MAKE) test
+	PATH=$$PWD/bin:$$PATH $(MAKE) test-cli
 %:
 	dh $@ --with python3 --buildsystem=pybuild

## apksigcopier 1.1.1

=== Makefile ===
SHELL     := /bin/bash
PYTHON    ?= python3

PYCOV     := $(PYTHON) -mcoverage run --source apksigcopier
PYCOVCLI  := $(PYCOV) -a apksigcopier/__init__.py

export PYTHONWARNINGS := default

.PHONY: all install test test-cli doctest coverage lint lint-extra clean cleanup
.PHONY: test-apks test-apks-compare-in test-apks-compare-self test-apks-copy

all: apksigcopier.1

install:
	$(PYTHON) -mpip install -e .

test: test-cli doctest lint lint-extra

test-cli:
	# TODO
	apksigcopier --version

doctest:
	# NB: uses test/apks/apks/*.apk
	$(PYTHON) -m doctest apksigcopier/__init__.py

coverage:
	# NB: uses test/apks/apks/*.apk & modifies .tmp
	mkdir -p .tmp/meta
	$(PYCOV) -m doctest apksigcopier/__init__.py
	$(PYCOVCLI) extract test/apks/apks/golden-aligned-v1v2v3-out.apk .tmp/meta
	$(PYCOVCLI) patch .tmp/meta test/apks/apks/golden-aligned-in.apk .tmp/patched.apk
	$(PYCOVCLI) copy test/apks/apks/golden-aligned-v1v2v3-out.apk \
	                 test/apks/apks/golden-aligned-in.apk .tmp/copied.apk
	$(PYCOVCLI) compare test/apks/apks/golden-aligned-v1v2v3-out.apk \
	         --unsigned test/apks/apks/golden-aligned-in.apk
	apksigner verify --verbose .tmp/patched.apk
	apksigner verify --verbose .tmp/copied.apk
	$(PYTHON) -mcoverage html
	$(PYTHON) -mcoverage report

test-apks: test-apks-compare-in test-apks-compare-self test-apks-copy

test-apks-compare-in:
	cd test && ./test-compare-in.sh

test-apks-compare-self:
	cd test && diff -Naur test-compare-self.out <( ./test-compare-self.sh \
	  | sed -r 's!/tmp/[^/]*/!/tmp/.../!' \
	  | sed -r 's!Expected: <[0-9a-f]+>, actual: <[0-9a-f]+>!Expected: <...>, actual: <...>!' )

test-apks-copy:
	cd test && diff -Naur test-copy.out <( $(PYTHON) ./test-copy.py )

lint:
	flake8 apksigcopier/__init__.py
	pylint apksigcopier/__init__.py

lint-extra:
	mypy --strict --disallow-any-unimported apksigcopier/__init__.py

clean: cleanup
	rm -fr apksigcopier.egg-info/

cleanup:
	find -name '*~' -delete -print
	rm -fr __pycache__/ .mypy_cache/
	rm -fr build/ dist/
	rm -fr .coverage htmlcov/
	rm -fr apksigcopier.1
	rm -fr .tmp/

%.1: %.1.md
	pandoc -s -t man -o $@ $<

.PHONY: _package _publish

_package:
	SOURCE_DATE_EPOCH="$$( git log -1 --pretty=%ct )" \
	  $(PYTHON) setup.py sdist bdist_wheel
	twine check dist/*

_publish: cleanup _package
	read -r -p "Are you sure? "; \
	[[ "$$REPLY" == [Yy]* ]] && twine upload dist/*

=== debian/changelog ===
apksigcopier (1.1.1-1) unstable; urgency=medium

  * New upstream version 1.1.1.
  * d/rules:
    - drop --with python3 (in favour of dh-sequence-python3).
  * d/control:
    - add Build-Depends: dh-sequence-python3.
    - bump Standards-Version to 4.6.2 (no changes required).
  * d/copyright: bump year to 2023.
  * d/docs: add changelog.txt.

 -- FC Stegerman <flx@obfusk.net>  Thu, 16 Feb 2023 21:57:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,14 @@
 Source: apksigcopier
 Section: misc
 Priority: optional
-Maintainer: Felix C. Stegerman <flx@obfusk.net>
+Maintainer: FC Stegerman <flx@obfusk.net>
 Build-Depends: debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                python3-all,
                python3-click,
                python3-setuptools,
-               flake8,
-               pylint,
-               mypy,
                pandoc,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/obfusk/apksigcopier.git
 Vcs-Browser: https://salsa.debian.org/obfusk/apksigcopier
 Homepage: https://github.com/obfusk/apksigcopier

=== debian/rules ===
--- 
+++ 
@@ -6,4 +6,4 @@
 override_dh_auto_test:
 	PATH=$$PWD/bin:$$PATH $(MAKE) test-cli
 %:
-	dh $@ --with python3 --buildsystem=pybuild
+	dh $@ --buildsystem=pybuild

=== debian/watch ===
version=4
opts="mode=git,pgpmode=gittag" \
https://github.com/obfusk/apksigcopier.git refs/tags/v([\d\.]+)
